/*global jQuery */

(function($) {
	var toString = Object.prototype.toString;

	function isEqual(a, b) {
		if ( a === b ) { return true; }
		if ( typeof a === 'function' || typeof b === 'function' ) { return true; } // ignore functions
		if ( typeof a !== typeof b || a == null || b == null ) { return false; }
		if ( toString.call(a) === '[object Object]' ) {
			var k;
			for (k in a) {
				if ( !isEqual(a[k], b[k]) ) { return false; }
			}
			return true;
		}
		if ( $.isArray(a) && $.isArray(b) && a.length === b.length ) {
			var i = a.length;
			while (i--) {
				if ( !isEqual(a[i], b[i]) ) { return false; }
			}
			return true;
		}
		return false;
	}
	
	$.isEqual = isEqual;

})(jQuery);

