/*jslint forin:true */
/*global jQuery, ManageLayoutsDWR */

jQuery(function($) {
	
	$.fn.atbPanelCSS = function(prop, val, palette) {
		var self = this;
		
		if ( val === 'empty' ) {
			val = '';
		}
		
		// Ignore non-CSS props
		switch (prop) {
			case "defer":
			case "content":
			case "renderMode":
				return;
		}
		
		switch (prop) {
			case "backgroundImage":
				if ( val && /([^:]*:){0,1}[^\^]*^.*/.test(val) ) {
					ManageLayoutsDWR.getBackgroundImage(val, function(bgImage) {
						if ( bgImage ) {
							self.css(prop, bgImage);
						}
					});
				} else {
					self.css(prop, val || "");
				}
				break;

			case "backgroundColor":
			case "borderColor":
			case "color":
				self.css(prop, palette[val] || val || "");
				break;

			case "visible":
				self.toggleClass('hidden', !val);
				break;

			case "collapse":
				// NOTE: collapse should have no effect on the preview
//				self.toggleClass('hidden', val);
				break;

			default:
				self.css(prop, val);
		}
	};
	
	$('.layout-preview')
		.closest('.atb-layout-data')

		.bind('atb-panel-changed.layout-preview', function(event, panelId, panelData) {
			var palette = $(this).data('atb-palette') || {};
			
			$('[data-panel='+panelId+']', this).each(function() {
				var panel = $(this), prop;
				for ( prop in panelData ) {
					panel.atbPanelCSS(prop, panelData[prop], palette);
				}
			});
		})

		.bind('atb-layout-updated.layout-preview', function(event, layoutId, layoutData) {
			layoutData = layoutData || $(this).data('atb-layout');
			
			if ( layoutData ) {
				$('[data-panel]', this).each(function() {
					var panelId = $.attr(this, 'data-panel');
					$(this).trigger('atb-panel-changed', [ panelId, layoutData[panelId] ]);
				});
			}
		})
		
		.trigger('atb-layout-refresh.layout-preview');

});

