/*global jQuery, ManageLayoutsDWR */

(function($) {
	var groupData = [];
	
	ManageLayoutsDWR.getGroups(function(data) {
		groupData = data;
	});

	$('#layout-manager-permissions .permission-list')
		.bind('atb-field-changed', function() {
			$(this).trigger('change.tokenlist');
		})
		// Convert to a token list
		.tokenlist({
			validate: function(value) {
				return $.inArray(value, groupData) >= 0;
			}
		})
		.each(function() {
			var acl = $(this).tokenlist('items');
			
			// Add the Autocomplete to the input field of the tokenlist
			$(this)
				.tokenlist('input')
				.autocomplete({
					source: function(request, response) {
						// escape regex characters
						var matcher = new RegExp($.ui.autocomplete.escapeRegex(request.term), "i");
						return $.grep(groupData, function(value) {
							// also filter out existing items
							return matcher.test(value) && $.inArray(value, acl);
						});
					},
					delay: 0,
					change: function() {
						$(this).trigger('change');
					}
				});
		});

	$(document)
		.bind('atb-layout-updated atb-fields-ready', function() {
			$('#layout-manager-permissions input:text.layout-field').trigger('change.tokenlist');
		});

})(jQuery);

