/*global jQuery, confirm */

(function($) {
	
	$('#layout-manager-panel-editor')
		
		.bind('atb-refresh.panel-editor', function(event) {
			var panelId = $(this).attr('data-ref'),
				panelData = $('#layout-manager').data('atb-layout')[panelId];
			
			// Set the preview panel id so it gets updated
			$('#panel-display').attr('data-panel', panelId);
			
			// Force a panel update
			$(this).trigger('atb-panel-changed', [ panelId, panelData ]);
		})
		
		.bind('atb-fields-ready.panel-editor', function(event) {
			// Disable any tabs that don't have any active fields
			$(':role(tab)', this).each(function() {
				var tabpanel = $.roles.slaves(this),
					empty = !tabpanel.find('.atb-field').length;
				
				$(this)
					.attr('aria-disabled', empty)
					// TODO: tabs should respond to aria-disabled by changing the ui-state itself
					.toggleClass('ui-state-disabled', empty);
				
				tabpanel.toggleClass('ui-state-disabled', empty);
			});
		});
		
	$('.layout-preview')
	
		.bind('click.preview-edit', function(event) {
			var panelId = $(event.target).closest('[data-panel]').attr('data-panel');
			
			if ( panelId ) {
				var dialog = $('#layout-manager-panel-editor');
				
				if ( dialog.hasClass('dialog-modified') ) {
					// TODO: Extract confirm message from markup
					if ( confirm("You have unapplied panel changes, continue and lose the changes?") ) {
						dialog.trigger('dialog-undo');
					} else {
						return;
					}
				}

				dialog
					.attr('data-ref', panelId)
					.trigger('atb-activate');
			}
		});

	$('#layout-manager')
		
		.bind('atb-panel-changed.preview-edit', function(event, panelId, props) {
			var visible = props && props.visible;
			
			if ( visible === true || visible === false ) {
				var checkbox = $('#layout-manager-panel-toggles :checkbox[name='+panelId+']');
				checkbox[0].checked = visible;
				
				// Disable slider toggles if sidebar is hidden
				switch (panelId) {
				case 'leftSidebar':
				case 'rightSidebar':
					panelId = panelId.replace('Sidebar','Slider');
					checkbox = $('#layout-manager-panel-toggles :checkbox[name='+panelId+']');
					if ( !visible ) {
						checkbox.attr('checked', false).trigger('change');
					}
					checkbox.attr('disabled', !visible);
					break;
				}
			}
		})
	
		.bind('atb-field-changed.preview-edit', function(event, field) {
			var data = field && field.getDataPair().obj;
			// Is this a panel field?
			if ( data && data.panelId ) {
				$(this).trigger('atb-panel-changed', [ data.panelId(), data ]);
			}
		});

})(jQuery);

