/*jslint bitwise: true, eqeqeq: true, nomen: true, undef: true */
/*global jQuery, ThemeAdminDWR */

jQuery(function($) {

	var panel = $('#defaultlayout-panel');

	function busy() { panel.busy(true); }
	function done() { panel.busy(false); }
	
	// Setup special behaviour: when the layoutId is '@SPACEKEY@',
	// the SELECT is disabled and the checkbox is checked.
	$('.default-layout-form', panel).each(function() {

		var select = $('select.layout-selector', this);
		
		// Custom renderer for the SELECT
		select.data('mvc-setter', function(v) {
			// Disable the SELECT if the value is '@SPACEKEY@'
			var isSpaceKey = (v === '@SPACEKEY@');
			this.disabled = isSpaceKey;
			if (!isSpaceKey) {
				$(this).val(v);
			}
		});
		
		// Custom reader for the checkbox
		$(':checkbox[value=@SPACEKEY@]', this).data('mvc-getter', function() {
			// Return the value of the SELECT if not checked
			return this.checked ? '@SPACEKEY@' : select.val();
		});
	});

	// Ensure layout data is loaded
//	$.adaptavist.layouts.dwr();
	
	$.mvc('/defaultlayout')
		.dwr(ThemeAdminDWR.getDefaults)
		.dwrGo(function() {
//			$.adaptavist.layouts.setup(panel);

			$(panel).mvcInit();

			// Save changes
			$.mvc('/defaultlayout/[@GLOBAL@SPACE@TYPE@,@PERSONAL@SPACE@TYPE@]/-')
				.key('layoutId').bind(function(ev) {
					var	spacekey = ev.target.up().key(),
						descPath = $.mvc(ev.target).key('description');

					busy();
					ThemeAdminDWR.setDefaultLayout(spacekey, ev.value, function(e) {
						// Load the description of the new layout
						ThemeAdminDWR.getDefaults(function(data) {
							descPath.val(data[spacekey].description);
							done();
						});
					});
				})
				.key('locked').bind(function(ev) {
					busy();
					ThemeAdminDWR.lockDefaultLayout(ev.target.up().key(), ev.value, done);
				});
			
			panel.trigger('ready');
	});
});

